module Vetor where

-- =========================================================================
-- Esse arquivo define o Vetor2D e as funcoes referentes a ele que serao
-- utilizadas no projeto
-- =========================================================================

-- =========================================================================
-- Vetor 2d que indica a posicao do Tetromino
data Vetor2D = Vetor2D { _x :: Int
                       , _y :: Int
                       } deriving Eq

-- =========================================================================
-- Instance de Num para vetor vai facilitar na hora de realizarmos a soma de
-- vetores. As demais funcoes soh foram implementadas pois o haskell necessita
-- delas
instance Num Vetor2D where
    -- ====================================
    -- A soma eh definida como a soma usual de vetores
    v1 + v2 = Vetor2D x' y'
        where
            x' = (_x v1) + (_x v2)
            y' = (_y v1) + (_y v2)
    
    -- ====================================
    -- O produto eh definido como o produto direto entre vetores
    v1 * v2 = Vetor2D x' y'
        where
            x' = (_x v1) * (_x v2)
            y' = (_y v1) * (_y v2)

    -- ===================================
    abs v = Vetor2D (abs $ _x v) (abs $ _y v)
    fromInteger i = Vetor2D (fromInteger i) (0)
    signum v = Vetor2D (signum $ _x v) (signum $ _y v)
    negate v = Vetor2D (negate $ _x v) (negate $ _y v)

instance Show Vetor2D where
    show (Vetor2D x y) = "(" ++ (show x) ++ ", " ++ (show y) ++ ")"
